define bi_ndenv::npm::package (
    $package_name = $title,
    $version = undef,
    $scope = undef,
    $save = undef,
    $save_dev = undef,
    $save_optional = undef,
    $save_exact = undef,
    $cwd = undef,
    $user = undef,
    $ensure = undef,
    $global = false,
    $http_proxy = undef,
    $https_proxy = undef,
) {

    if $ensure == undef or !is_string($ensure) { 
        fail("'ensure' must be defined") 
    }
    
    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    case $ensure {
        'present': {
            bi_ndenv::npm::install { "$user/$package_name":
                package_name => $package_name,
                version => $version,
                scope => $scope,
                save => $save,
                save_dev => $save_dev,
                save_optional => $save_optional,
                save_exact => $save_exact,
                cwd => $cwd,
                user => $user,
                global => $global,
                http_proxy => $http_proxy,
                https_proxy => $https_proxy,
            }
            ->
            bi_ndenv::rehash { "$user/rehash for $package_name":
                user => $user,
                refreshonly => true,
            }
        }
        
        'absent': {
            bi_ndenv::npm::uninstall { "$user/$package_name":
                package_name => $package_name,
                scope => $scope,
                save => $save,
                save_dev => $save_dev,
                save_optional => $save_optional,
                save_exact => $save_exact,
                cwd => $cwd,
                user => $user,
                global => $global,
            }
            ->
            bi_ndenv::npm::prune { "$user/prune for $package_name":
                user => $user,
                refreshonly => true,
            }
            ->
            bi_ndenv::rehash { "$user/rehash for $package_name":
                user => $user,
                refreshonly => true,
            }
        }
    }
}
