define bi_ndenv::npm::prune (
    $production = undef,
    $cwd = undef,
    $user = undef,
    $refreshonly = undef,
) {
    require bi_ndenv
    require bi_grep
    require bi_bash
    
    if $cwd == undef or !is_string($cwd) { 
        fail("'cwd' must be defined") 
    }
    
    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    if $production != undef and !is_bool($production) { 
        fail("'production' must be a bool") 
    }
    
    $arg_production = $production ? {
        true => '--production',
        default => undef,
    }
    
    $args = join(delete_undef_values([ 
        $arg_production, 
    ]), " ")
    
    $command = "npm prune $args"
    debug ("command: $command")

    bi_bash::exec { "$user/$command":
        command => $command,
        user => $user,
        cwd => $cwd,
        refreshonly => $refreshonly,
    }
}
